{ $Id: WMSTestGUI.pas,v 1.18 2003/11/17 11:11:49 msr Exp $

  Copyright (C) 2003 Sourcepole AG.  All rights reserved.
}
{ test gui with the installed components @link(TCmpWMSClient) and @link(TMapViewer) }
unit WMSTestGUI;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QComCtrls, QActnList, QMenus, QExtCtrls, StrUtils,
  IdBaseComponent, IdAntiFreezeBase, IdAntiFreeze, GISClient, CmpWMSClient,
  CmpMapViewer, CmpMSClient, QT, CustomCmpClient;

type
  // GUI to test the installed components @link(TCmpWMSClient) and @link(TMapViewer)
  TFrmWMSTestGUI = class(TForm)
    mmWMSClient: TMainMenu;
    miFile: TMenuItem;
    miExit: TMenuItem;
    aclWMSClient: TActionList; 
    actExit: TAction; 
    actCapabilities: TAction;
    actMap: TAction;  
    actInfo: TAction;
    actGetMapRequest: TAction;
    actGetInfoRequest: TAction;
    actExecMapRequest: TAction;
    actExecInfoRequest: TAction; 
    actImgGetMap: TAction;
    actImgZoomIn: TAction;
    actImgZoomOut: TAction; 
    actImgFullExtend: TAction;
    actImageZoomIn: TAction;
    actImgRefreshMap: TAction; 
    actMapRumn: TAction;
    actInfoRumn: TAction;
    actGetMapRumn: TAction;
    actGetInfoRumn: TAction;
    actExecMapRumn: TAction;
    actExecInfoRumn: TAction;
    stbWMSClient: TStatusBar;
    pgcWMSClient: TPageControl;
    tbcImage: TTabSheet;  
    tbcConfigUMN: TTabSheet;
    tbcConfigWMS: TTabSheet;
    tbcLog: TTabSheet;
    memLog: TMemo;
    btnMapRequestDefault: TButton;   
    btnInfoRequestDefault: TButton;
    btnGetCap: TButton;   
    btnExecMapRequest: TButton;
    btnExecInfoRequest: TButton;  
    btnGetMap: TButton;
    btnGetInfo: TButton;  
    btnZoomIn: TButton;
    btnZoomOut: TButton;
    btnFullExtend: TButton;
    btnRefresh: TButton;  
    btnMapRumn: TButton;
    btnGetMapRumn: TButton;
    btnExecMapRumn: TButton;
    btnInfoRumn: TButton;
    btnGetInfoRumn: TButton;
    btnExecInfoRumn: TButton;
    chkNavBtn: TCheckBox;
    chkNavImg: TCheckBox;
    edtMapRequest: TEdit;
    edtInfoRequest: TEdit;
    edtMinX: TEdit;
    edtMaxX: TEdit;
    edtMinY: TEdit;
    edtMaxY: TEdit;
    edtPosX: TEdit;
    edtPosY: TEdit;
    edtLayers: TEdit;
    edtImageFormat: TEdit;
    edtStyles: TEdit;
    edtVersion: TEdit; 
    edtSRS: TEdit;
    edtQueryLayers: TEdit;  
    edtURLumn: TEdit;
    edtMapRumn: TEdit;
    edtInfoRumn: TEdit;
    edtMinXumn: TEdit;
    edtMaxXumn: TEdit;
    edtMaxYumn: TEdit;
    edtMinYumn: TEdit;
    edtLayersumn: TEdit;
    edtPosXumn: TEdit;
    edtPosYumn: TEdit;
    edtQueryLayersumn: TEdit;
    edtVersionumn: TEdit;
    lblUrl: TLabel;
    lblMapRequest: TLabel;
    lblInfoRequest: TLabel;
    lblLayerList: TLabel;
    lblImageFormat: TLabel;
    lblStyle: TLabel;
    lblMinX: TLabel;
    lblMaxX: TLabel;
    lblMinY: TLabel;
    lblMaxY: TLabel;
    lblPosX: TLabel;
    lblPosY: TLabel;
    lblVersion: TLabel;
    lblSRS: TLabel;
    lblQueryLayers: TLabel; 
    lblURLumn: TLabel;  
    lblMapRumn: TLabel; 
    lblInfoRumn: TLabel;  
    lblMinXumn: TLabel;
    lblMaxXumn: TLabel;
    lblMinYumn: TLabel;
    lblMaxYumn: TLabel;  
    lblLayersumn: TLabel;
    lblPosXumn: TLabel;
    lblPosYumn: TLabel;
    lblQueryLayersumn: TLabel; 
    lblVersionumn: TLabel;
    pnlImageTop: TPanel;
    rgMapClients: TRadioGroup;
    rgMode: TRadioGroup; 
    imgWMS: TImage; 
    imgUMN: TImage;
    wmsClient: TCmpWMSClient;
    umnClient: TCmpUMNClient;
    imgGIS: TMapViewer;
    antiFreeze: TIdAntiFreeze;
    edtUrl: TEdit;
    pnlLogButton: TPanel;
    btnClear: TButton;
    actLegendumn: TAction;
    actGetLegendRumn: TAction;
    actExecLegendRumn: TAction;
    btnGetLegendumn: TButton;
    btnOverviewMapumn: TButton;
    actOverviewRumn: TAction;
    actGetOverviewRumn: TAction;
    actExecOverviewRumn: TAction;
    btnGetLegend: TButton;
    lblLegendLayer: TLabel;
    edtLegendLayer: TEdit;
    btnGetOverviewMap: TButton;
    actGetLegend: TAction;
    actGetOverviewMap: TAction;
    procedure actCapabilitiesExecute(Sender: TObject);
    procedure actMapExecute(Sender: TObject);
    procedure actGetMapRequestExecute(Sender: TObject);
    procedure actExecMapRequestExecute(Sender: TObject);
    procedure btnImgGetMapClick(Sender: TObject);
    procedure actImgGetMapExecute(Sender: TObject);
    procedure actImgZoomInExecute(Sender: TObject);
    procedure actImgZoomOutExecute(Sender: TObject);
    procedure actImgFullExtendExecute(Sender: TObject);
    procedure actImgRefreshMapExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure chkNavBtnClick(Sender: TObject);
    procedure chkNavImgClick(Sender: TObject);
    procedure rgMapClientsClick(Sender: TObject);
    procedure rgModeClick(Sender: TObject);
    procedure actExitExecute(Sender: TObject);
    procedure pgcWMSClientChange(Sender: TObject);
    procedure actGetInfoRequestExecute(Sender: TObject);
    procedure actExecInfoRequestExecute(Sender: TObject);
    procedure actInfoExecute(Sender: TObject);
    procedure actMapRumnExecute(Sender: TObject);
    procedure actInfoRumnExecute(Sender: TObject);
    procedure actGetMapRumnExecute(Sender: TObject);
    procedure actGetInfoRumnExecute(Sender: TObject);
    procedure actExecMapRumnExecute(Sender: TObject);
    procedure actExecInfoRumnExecute(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure actLegendumnExecute(Sender: TObject);
    procedure actExecLegendRumnExecute(Sender: TObject);
    procedure actOverviewRumnExecute(Sender: TObject);
    procedure actGetLegendExecute(Sender: TObject);
    procedure actGetOverviewMapExecute(Sender: TObject);
  private
    { Private-Deklarationen } 
    FFirstRunWMS1: Boolean;
    FFirstRunUMN1: Boolean;
  public
    { Public-Deklarationen }
  end;

var
  // test GUI TForm
  FrmWMSTestGUI: TFrmWMSTestGUI;

implementation

{$R *.xfm}   

procedure TFrmWMSTestGUI.FormCreate(Sender: TObject);
begin
  FFirstRunWMS1 := true;
  FFirstRunUMN1 := true;

  edtUrlumn.Text := umnClient.Url;
  edtLayersumn.Text := umnClient.Layers;
  edtVersionumn.Text := umnClient.Version;
  edtMinXumn.Text := FloatToStr(umnClient.MinX);
  edtMaxXumn.Text := FloatToStr(umnClient.MaxX);
  edtMinYumn.Text := FloatToStr(umnClient.MinY);
  edtMaxYumn.Text := FloatToStr(umnClient.MaxY);
  edtQueryLayersumn.Text := umnClient.InfoLayers;
  edtPosXumn.Text := IntToStr(Round(imgUMN.Width / 2));
  edtPosYumn.Text := IntToStr(Round(imgUMN.Height / 2));

  edtUrl.Text := wmsClient.Url;
  edtImageFormat.Text := wmsClient.ImageFormat;
  edtStyles.Text := wmsClient.Style;
  edtLayers.Text := wmsClient.Layers;
  edtVersion.Text := wmsClient.Version;
  edtSRS.Text := wmsClient.SRS;
  edtMinX.Text := FloatToStr(wmsClient.MinX);
  edtMaxX.Text := FloatToStr(wmsClient.MaxX);
  edtMinY.Text := FloatToStr(wmsClient.MinY);
  edtMaxY.Text := FloatToStr(wmsClient.MaxY);
  edtQueryLayers.Text := wmsClient.InfoLayers;
  edtPosX.Text := IntToStr(Round(imgWMS.Width / 2));
  edtPosY.Text := IntToStr(Round(imgWMS.Height / 2));
  edtLegendLayer.Text := wmsClient.LegendLayer;
end;  

procedure TFrmWMSTestGUI.pgcWMSClientChange(Sender: TObject);
begin  
  edtUrlumn.Text := umnClient.Url;
  edtLayersumn.Text := umnClient.Layers;
  edtVersionumn.Text := umnClient.Version;
  edtMinXumn.Text := FloatToStr(umnClient.MinX);
  edtMaxXumn.Text := FloatToStr(umnClient.MaxX);
  edtMinYumn.Text := FloatToStr(umnClient.MinY);
  edtMaxYumn.Text := FloatToStr(umnClient.MaxY);
  edtQueryLayersumn.Text := umnClient.InfoLayers;

  edtUrl.Text := wmsClient.Url;
  edtImageFormat.Text := wmsClient.ImageFormat;
  edtStyles.Text := wmsClient.Style;
  edtLayers.Text := wmsClient.Layers;
  edtVersion.Text := wmsClient.Version;
  edtSRS.Text := wmsClient.SRS;
  edtMinX.Text := FloatToStr(wmsClient.MinX);
  edtMaxX.Text := FloatToStr(wmsClient.MaxX);
  edtMinY.Text := FloatToStr(wmsClient.MinY);
  edtMaxY.Text := FloatToStr(wmsClient.MaxY);
end;  

// wms config actions

procedure TFrmWMSTestGUI.actCapabilitiesExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Capabilities Request (WMS) ...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting Url (WMS)');
  wmsClient.Url := edtUrl.Text;

  memLog.Lines.Add('--- GetCapabilities (WMS)');
  wmsClient.GetCapabilities;

  memLog.Lines.Add('--- Receive the capabilities string (WMS)');
  memLog.Lines.Add(wmsClient.Capabilities);

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actMapExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Map Request (WMS) ...';
                                                   
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (WMS)');
  wmsClient.Url := edtUrl.Text;
  wmsClient.ImageWidth := imgWMS.Width;
  wmsClient.ImageHeight := imgWMS.Height;
  wmsClient.ImageFormat := edtImageFormat.Text;
  wmsClient.Style := edtStyles.Text;
  wmsClient.Layers := edtLayers.Text;
  wmsClient.Version := edtVersion.Text;
  wmsClient.SRS := edtSRS.Text;
  wmsClient.MinX := StrToFloat(edtMinX.Text);
  wmsClient.MaxX := StrToFloat(edtMaxX.Text);
  wmsClient.MinY := StrToFloat(edtMinY.Text);
  wmsClient.MaxY := StrToFloat(edtMaxY.Text);

  memLog.Lines.Add('--- Get Map (WMS)');
  wmsClient.GetMap;

  memLog.Lines.Add('--- Map Request (WMS)');
  memLog.Lines.Add(wmsClient.MapRequest);
  edtMapRequest.Text := wmsClient.MapRequest;

  memLog.Lines.Add('--- Map (WMS)');
  imgWMS.Picture.Bitmap := wmsClient.Map;
  
  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actInfoExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Info Request (WMS) ...';
                                                 
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (WMS)');
  wmsClient.Url := edtUrl.Text;
  wmsClient.ImageWidth := imgWMS.Width;
  wmsClient.ImageHeight := imgWMS.Height;
  wmsClient.ImageFormat := edtImageFormat.Text;
  wmsClient.Style := edtStyles.Text;
  wmsClient.Layers := edtLayers.Text;
  wmsClient.Version := edtVersion.Text;
  wmsClient.SRS := edtSRS.Text;
  wmsClient.MinX := StrToFloat(edtMinX.Text);
  wmsClient.MaxX := StrToFloat(edtMaxX.Text);
  wmsClient.MinY := StrToFloat(edtMinY.Text);
  wmsClient.MaxY := StrToFloat(edtMaxY.Text);

  memLog.Lines.Add('--- Get Info (WMS)');
  wmsClient.GetInfo(StrToInt(edtPosX.text), StrToInt(edtPosY.Text));

  memLog.Lines.Add('--- Info Request (WMS)');
  memLog.Lines.Add(wmsClient.InfoRequest);
  edtInfoRequest.Text := wmsClient.InfoRequest;

  memLog.Lines.Add('--- Info (WMS)' + #13#10 + wmsclient.Info.Text);
  
  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actGetMapRequestExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Map Request (WMS) ...';
                                          
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting WMS client object (WMS)');
  wmsClient.Url := edtUrl.Text;
  wmsClient.ImageWidth := imgWMS.Width;
  wmsClient.ImageHeight := imgWMS.Height;
  wmsClient.ImageFormat := edtImageFormat.Text;
  wmsClient.Style := edtStyles.Text;
  wmsClient.Layers := edtLayers.Text;
  wmsClient.Version := edtVersion.Text;
  wmsClient.SRS := edtSRS.Text;
  wmsClient.MinX := StrToFloat(edtMinX.Text);
  wmsClient.MaxX := StrToFloat(edtMaxX.Text);
  wmsClient.MinY := StrToFloat(edtMinY.Text);
  wmsClient.MaxY := StrToFloat(edtMaxY.Text);

  memLog.Lines.Add('--- Get Map Request (WMS)');
  wmsClient.GetMapRequest;
  memLog.Lines.Add('--- Map Request (WMS)');
  memLog.Lines.Add(wmsClient.MapRequest);
  edtMapRequest.Text := wmsClient.MapRequest;

  stbWMSClient.Panels[0].Text := 'Ready';
end; 

procedure TFrmWMSTestGUI.actGetInfoRequestExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Info Request (WMS) ...';
                                               
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting WMS client object (WMS)');
  wmsClient.Url := edtUrl.Text;
  wmsClient.ImageWidth := imgWMS.Width;
  wmsClient.ImageHeight := imgWMS.Height;
  wmsClient.ImageFormat := edtImageFormat.Text;
  wmsClient.Style := edtStyles.Text;
  wmsClient.Layers := edtLayers.Text;
  wmsClient.Version := edtVersion.Text;
  wmsClient.SRS := edtSRS.Text;
  wmsClient.MinX := StrToFloat(edtMinX.Text);
  wmsClient.MaxX := StrToFloat(edtMaxX.Text);
  wmsClient.MinY := StrToFloat(edtMinY.Text);
  wmsClient.MaxY := StrToFloat(edtMaxY.Text);

  memLog.Lines.Add('--- Get Info Request (WMS)');
  wmsClient.GetInfoRequest(StrToInt(edtPosX.text), StrToInt(edtPosY.Text));
  memLog.Lines.Add('--- Info Request (WMS)');
  memLog.Lines.Add(wmsClient.InfoRequest);
  edtInfoRequest.Text := wmsClient.InfoRequest;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actExecMapRequestExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Exec Map Request (WMS) ...';
                                         
  memLog.Lines.Add('--------------------------------------------------------');
  wmsClient.MapRequest := edtMapRequest.Text;
  memLog.Lines.Add('--- Exec Map Request (WMS)');
  wmsClient.ExecMapRequest;
  imgWMS.Picture.Bitmap := wmsClient.Map;

  stbWMSClient.Panels[0].Text := 'Ready';
end;  

procedure TFrmWMSTestGUI.actExecInfoRequestExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Exec Info Request ...';
                            
  memLog.Lines.Add('--------------------------------------------------------');
  wmsClient.InfoRequest := edtInfoRequest.Text;
  memLog.Lines.Add('--- Exec Info Request (WMS)');
  wmsClient.ExecInfoRequest;
  memLog.Lines.Add('--- Info (WMS)' + #13#10 + wmsclient.Info.Text);

  stbWMSClient.Panels[0].Text := 'Ready';
end; 

procedure TFrmWMSTestGUI.actGetLegendExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Legend (WMS)...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (WMS)');
  wmsClient.Url := edtURL.Text;
  wmsClient.LegendLayer := edtLegendLayer.Text;
  wmsClient.LegendWidth := imgWMS.Width;
  wmsClient.LegendHeight := imgWMS.Height;

  memLog.Lines.Add('--- Get Legend Request (WMS)');
  wmsClient.GetLegend;
  memLog.Lines.Add('--- Legend Request (WMS)');
  memLog.Lines.Add(wmsClient.LegendRequest);

  memLog.Lines.Add('--- Legend (WMS)');
  imgWMS.Picture.Bitmap := wmsClient.Legend;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actGetOverviewMapExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Overview (WMS)...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (WMS)');
  wmsClient.Url := edtUrl.Text;
  wmsClient.ImageWidth := imgWMS.Width;
  wmsClient.ImageHeight := imgWMS.Height;
  wmsClient.ImageFormat := edtImageFormat.Text;
  wmsClient.Style := edtStyles.Text;
  wmsClient.Layers := edtLayers.Text;
  wmsClient.Version := edtVersion.Text;
  wmsClient.SRS := edtSRS.Text;
  wmsClient.MinX := StrToFloat(edtMinX.Text);
  wmsClient.MaxX := StrToFloat(edtMaxX.Text);
  wmsClient.MinY := StrToFloat(edtMinY.Text);
  wmsClient.MaxY := StrToFloat(edtMaxY.Text);

  memLog.Lines.Add('--- Get Overview Request (WMS)');
  wmsClient.GetOverviewMap;
  memLog.Lines.Add('--- Overview Request (WMS)');
  memLog.Lines.Add(wmsClient.OverviewMapRequest);

  memLog.Lines.Add('--- Overview (WMS)');
  imgWMS.Picture.Bitmap := wmsClient.OverviewMap;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

// umn config actions

procedure TFrmWMSTestGUI.actMapRumnExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Map Request (UMN)...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (UMN)');
  umnClient.Url := edtURLumn.Text;
  umnClient.ImageWidth := imgUMN.Width;
  umnClient.ImageHeight := imgUMN.Height;
  umnClient.Layers := edtLayersumn.Text;
  umnClient.Version := edtVersionumn.Text;
  umnClient.MinX := StrToFloat(edtMinXumn.Text);
  umnClient.MaxX := StrToFloat(edtMaxXumn.Text);
  umnClient.MinY := StrToFloat(edtMinYumn.Text);
  umnClient.MaxY := StrToFloat(edtMaxYumn.Text);

  memLog.Lines.Add('--- Get Map Request (UMN)');
  umnClient.GetMap;
  memLog.Lines.Add('--- Map Request (UMN)');
  memLog.Lines.Add(umnClient.MapRequest);
  edtMapRumn.Text := umnClient.MapRequest;

  memLog.Lines.Add('--- Map (UMN)');
  imgUMN.Picture.Bitmap := umnClient.Map;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actInfoRumnExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Info (UMN)...';
                                                     
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (UMN)');
  umnClient.Url := edtURLumn.Text;
  umnClient.ImageWidth := imgUMN.Width;
  umnClient.ImageHeight := imgUMN.Height;
  umnClient.Layers := edtLayersumn.Text;
  umnClient.Version := edtVersionumn.Text;
  umnClient.MinX := StrToFloat(edtMinXumn.Text);
  umnClient.MaxX := StrToFloat(edtMaxXumn.Text);
  umnClient.MinY := StrToFloat(edtMinYumn.Text);
  umnClient.MaxY := StrToFloat(edtMaxYumn.Text);

  memLog.Lines.Add('--- Get Info (UMN)');
  umnClient.GetInfo(StrToInt(edtPosXumn.text), StrToInt(edtPosYumn.Text));
  memLog.Lines.Add('--- Info Request (UMN)');
  memLog.Lines.Add(umnClient.InfoRequest);
  edtInfoRumn.Text := umnClient.InfoRequest;

  memLog.Lines.Add('--- Info (UMN)' + #13#10 + umnClient.Info.Text);

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actGetMapRumnExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Map Request (UMN)...';
                                                     
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (UMN)');
  umnClient.Url := edtURLumn.Text;
  umnClient.ImageWidth := imgUMN.Width;
  umnClient.ImageHeight := imgUMN.Height;
  umnClient.Layers := edtLayersumn.Text;
  umnClient.Version := edtVersionumn.Text;
  umnClient.MinX := StrToFloat(edtMinXumn.Text);
  umnClient.MaxX := StrToFloat(edtMaxXumn.Text);
  umnClient.MinY := StrToFloat(edtMinYumn.Text);
  umnClient.MaxY := StrToFloat(edtMaxYumn.Text);

  memLog.Lines.Add('--- Get Map Request (UMN)');
  umnClient.GetMapRequest;
  memLog.Lines.Add('--- Map Request (UMN)');
  memLog.Lines.Add(umnClient.MapRequest);
  edtMapRumn.Text := umnClient.MapRequest;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actGetInfoRumnExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Info Request (UMN)...';
                                                     
  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (UMN)');
  umnClient.Url := edtURLumn.Text;
  umnClient.ImageWidth := imgUMN.Width;
  umnClient.ImageHeight := imgUMN.Height;
  umnClient.Layers := edtLayersumn.Text;
  umnClient.Version := edtVersionumn.Text;
  umnClient.MinX := StrToFloat(edtMinXumn.Text);
  umnClient.MaxX := StrToFloat(edtMaxXumn.Text);
  umnClient.MinY := StrToFloat(edtMinYumn.Text);
  umnClient.MaxY := StrToFloat(edtMaxYumn.Text);

  memLog.Lines.Add('--- Get Info Request (UMN)');
  umnClient.GetInfoRequest(StrToInt(edtPosXumn.text), StrToInt(edtPosYumn.Text));
  memLog.Lines.Add('--- Info Request (UMN)');
  memLog.Lines.Add(umnClient.InfoRequest);
  edtInfoRumn.Text := umnClient.InfoRequest;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actExecMapRumnExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Exec Map Request (UMN)...';
                                                 
  memLog.Lines.Add('--------------------------------------------------------');
  umnClient.MapRequest := edtMapRumn.Text;
  memLog.Lines.Add('--- Exec Map Request (UMN)');
  umnClient.ExecMapRequest;

  memLog.Lines.Add('--- Map Request (UMN)');
  memLog.Lines.Add(umnClient.MapRequest);
  self.edtMapRumn.Text := umnClient.MapRequest;

  memLog.Lines.Add('--- Map (UMN)');
  imgUMN.Picture.Bitmap := umnClient.Map;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actExecInfoRumnExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Exec Info Request (UMN)...';

  memLog.Lines.Add('--------------------------------------------------------');
  umnClient.InfoRequest := edtInfoRumn.Text;
  memLog.Lines.Add('--- Exec Info Request (UMN)');
  umnClient.ExecInfoRequest;
  memLog.Lines.Add('--- Info Request (UMN)');
  memLog.Lines.Add(umnClient.InfoRequest);
  edtInfoRumn.Text := umnClient.InfoRequest;

  memLog.Lines.Add('--- Info (UMN)' + #13#10 + umnClient.Info.Text);

  stbWMSClient.Panels[0].Text := 'Ready';
end;

// legend actions

procedure TFrmWMSTestGUI.actLegendumnExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Legend (UMN)...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (UMN)');
  umnClient.Url := edtURLumn.Text;
  umnClient.Layers := edtLayersumn.Text;

  memLog.Lines.Add('--- Get Legend Request (UMN)');
  umnClient.GetLegend;
  memLog.Lines.Add('--- Legend Request (UMN)');
  memLog.Lines.Add(umnClient.LegendRequest);

  memLog.Lines.Add('--- Legend (UMN)');
  imgUMN.Picture.Bitmap := umnClient.Legend;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actOverviewRumnExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Get Overview (UMN)...';

  memLog.Lines.Add('--------------------------------------------------------');
  memLog.Lines.Add('--- Setting client object (UMN)');
  umnClient.Url := edtURLumn.Text;

  memLog.Lines.Add('--- Get Overview Request (UMN)');
  umnClient.GetOverviewMap;
  memLog.Lines.Add('--- Overview Request (UMN)');
  memLog.Lines.Add(umnClient.OverviewMapRequest);

  memLog.Lines.Add('--- Overview (UMN)');
  imgUMN.Picture.Bitmap := umnClient.OverviewMap;

  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actExecLegendRumnExecute(Sender: TObject);
begin

end;

// image actions

procedure TFrmWMSTestGUI.btnImgGetMapClick(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Start Map ...';
  imgGIS.StartMap;
  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actImgGetMapExecute(Sender: TObject);
begin  
  stbWMSClient.Panels[0].Text := 'Start Map ...';
  imgGIS.StartMap;
  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actImgZoomInExecute(Sender: TObject);
begin  
  stbWMSClient.Panels[0].Text := 'Zoom In ...';
  imgGIS.ZoomIn;  
  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actImgZoomOutExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Zoom Out ...';
  imgGIS.ZoomOut;   
  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actImgFullExtendExecute(Sender: TObject);
begin
  stbWMSClient.Panels[0].Text := 'Full Extend Map ...';
  imgGIS.ZoomToFullExtend;
  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.actImgRefreshMapExecute(Sender: TObject);
begin  
  stbWMSClient.Panels[0].Text := 'Refresh Map ...';
  imgGIS.RefreshMap;
  stbWMSClient.Panels[0].Text := 'Ready';
end;

procedure TFrmWMSTestGUI.chkNavBtnClick(Sender: TObject);
begin
  imgGIS.NavigationButtonOn := chkNavBtn.Checked;
end;

procedure TFrmWMSTestGUI.chkNavImgClick(Sender: TObject);
begin
  imgGIS.NavigationImageOn := chkNavImg.Checked;
end;

procedure TFrmWMSTestGUI.rgMapClientsClick(Sender: TObject);
begin
  if rgMapClients.ItemIndex = 0 then
  begin
    if FFirstRunWMS1 = false then
      imgGIS.ZoomToFullExtend;
    imgGIS.MAPClient := wmsClient;
    imgGIS.StartMap;
    FFirstRunWMS1 := false;
  end
  else if rgMapClients.ItemIndex = 1 then
  begin
    if FFirstRunUMN1 = false then
      imgGIS.ZoomToFullExtend;
    imgGIS.MAPClient := umnClient;
    imgGIS.StartMap;
    FFirstRunUMN1 := false;
  end;
end;

procedure TFrmWMSTestGUI.rgModeClick(Sender: TObject);
begin
  if (rgMode.ItemIndex < 1) or (rgMode.ItemIndex > 4) then
    imgGIS.NavigationMode := navNothing;
  if rgMode.ItemIndex = 1 then
    imgGIS.NavigationMode := navZoomIn; 
  if rgMode.ItemIndex = 2 then
    imgGIS.NavigationMode := navZoomOut;
  if rgMode.ItemIndex = 3 then
    imgGIS.NavigationMode := navMove;
  if rgMode.ItemIndex = 4 then
    imgGIS.NavigationMode := navInfo;
end;

procedure TFrmWMSTestGUI.actExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TFrmWMSTestGUI.btnClearClick(Sender: TObject);
begin
  memLog.Clear;
end;

end.
